#!/bin/bash

# Generate files for search form

# Set locale for sort order
export LC_ALL=C.UTF-8

cd /var/local/lib/websearch/

# Update text-files.list
if [ text-urls.list -nt text-files.list ] 
then
	rm text-files.list.bak
	mv text-files.list text-files.list.bak
	#> num-files.list
	> num-links.list
	#> num-titles.list
	#> num-urls.list
	> text-files.list
	CNT=1
	IFS=$'\t\n'
	while read FILE URL TITLE
	do
		# Can't index PDF
		if ( echo ${FILE} | egrep -h ".+[.]pdf$" > /dev/null )
		then
			continue
		fi
		printf "%04X\t" $CNT >> num-links.list
		echo "<a href=\"${URL}\">${TITLE}</a>" >> num-links.list
		echo "${FILE}"  >> text-files.list
		let CNT+=1
		if [ $CNT -gt 65535 ]
		then
			echo "Too many files in text-urls.list"
			exit 1
		fi
	done < text-urls.list
	IFS=$' \t\n'
fi

/usr/local/bin/gen-num-index links

# Test return value of cgi-index
if ! ( /usr/local/bin/cgi-index -a -d -f text-files.list -r -u )
then
	echo "Indexing error"
	exit 1
fi

# Update indexes
cd index/

mv links.idx   bak/
mv links-list  bak/
mv index.idx   bak/
mv index-list  bak/
mv words-list  bak/
if [ -f words.idx ]
then
	mv words.idx bak/
fi
if [ -f abstr-list ]
then
	mv abstr-list bak/
fi

mv new/links.idx   .
mv new/links-list  .
mv new/index.idx   .
mv new/index-list  .
mv new/words-list  .
if [ -f new/words.idx ]
then
	mv new/words.idx .
fi
if [ -f new/abstr-list ]
then
	mv new/abstr-list .
fi

